int mySend(nTask task, void *msg){
    int rc;
    /*indicamos que hay una tarea enviando un mensaje a task*/
    nSignalSem(ReceiveQueSem(task));

    /*esperamos que la tarea escuche nuestro Send */
    nWaitSem(SendAcceptedSem(task));
    
    putMsg(task, msg); /*dejamos el puntero en algun area global de mem
                        asociado a la tarea task, y CurrentTask() 
                        (que esta implicito en la llamada).*/

    /*Notificamos que la info ya esta en una referencia global */
    nSignalSem(MsgReadySem(task));

    /*Bloqueamos hasta recibir el nReply */
    nWaitSem(SendBlockSem(CurrentTask()));

    /*obtenemos el codigo de retorno */
    rc=getRC(CurrentTask());
    
    /*avismos que pueden destruir el rc original*/
    nSignalSem(OkRCSem(CurrentTask()) );

    return rc;
}

void *myReceive(nTask *ptask){
    void * msg;
    /*Esperamos que alguien nos quiera enviar un msg */
    nWaitSem(ReceiveQueueSem(CurrentTask()));

    /*Notifcamos que estamos dispuestos a aceptar */
    nSignalSem(SendAcceptedSem(CurrentTask()));
    
    /*Esperamos que alguien coloque el msg en un puntero global asociado
     * a esta CurrentTask() */
    nWaitSem(MsgReadySem(CurrentTask()));
    
    /* Colocamos la tarea que envia en ptask y 
     * retornamos el valor */
    msg =getMsg(ptask);
    return msg;
}

void myReply(nTask task, int rc){
    /* (colocamos el codigo de retonro en un area global de mem */
    putRC(task, rc);

    /* liberamos la tarea que esta pegada en nSend */
    nSignalSem(SendBlockSem(task) );
    
    /* esperamos que nSend copie el RC antes de seguir */
    nWaitSem(OkRCSem(task));
}
