#include <stdio.h>
#include <stdlib.h>
#include "nSystem.h"


typedef struct {
    nSem key;
    nTask task;
    int res;
} FUTURE;

FUTURE *future(int (*f)(int), int args);
int wrapper(FUTURE *fut, int (*f)(int), int args);
int touch(FUTURE *fut);

FUTURE *future(int (*f)(int), int args){
    FUTURE *fut = (FUTURE *) malloc(sizeof (FUTURE));
    fut->key = nMakeSem(1); // un mutex
    nWaitSem(fut->key); // tomo el mutex
    fut->task = nEmitTask(wrapper, fut, f, args);
    return fut;
}

int wrapper(FUTURE *fut, int (*f)(int), int args){
    fut->res = f(args);
    nSignalSem(fut->key); // libero el mutex
    nExitTask(0);
    return 0;
}

int touch(FUTURE *fut){
    nWaitSem(fut->key);
    nSignalSem(fut->key);
    return fut->res;
}

// main
int foo(int n);

nMain(){
  FUTURE *f;
  int result;
  srand(time(0));
  f = future(foo, 10000);
  printf("aca no estamos bloqueados\n");
  result = touch(f);
  printf("Terminamos con: %d\n", result);
}

int foo(int n){
  int i =0;
  for(;i < n; i++)
    if(i % 1000 == 0){
      int milis = 500 + (rand() % 1000);
      printf("Calculando: %d, durme: %d\n", i, milis);
      nSleep(milis);
    }
  return i;
}
